/*
 * bz2lib.c --
 *
 *	Loader for 'bz2' compression library.
 *
 * Copyright (c) 1996 Jan Nijtmans (Jan.Nijtmans.wxs.nl)
 * All rights reserved.
 *
 * CVS: $Id: bz2lib.c,v 1.4 1999/11/08 19:52:13 aku Exp $
 */

#include "transformInt.h"

#ifdef __WIN32__
#define BZ2_LIB_NAME "libbz2.dll"
#endif

#ifndef BZ2_LIB_NAME
#define BZ2_LIB_NAME "libbz2.so.1"
#endif

#ifndef BZLIB_SHARED_BUILD
static char* symbols [] = {
  "BZ2_bzCompress",
  "BZ2_bzCompressEnd",
  "BZ2_bzCompressInit",
  "BZ2_bzDecompress",
  "BZ2_bzDecompressEnd",
  "BZ2_bzDecompressInit",
  (char *) NULL
};
#endif


/*
 * Global variable containing the vectors into the 'bz2'-library.
 */

#ifdef BZLIB_SHARED_BUILD
bzFunctions bz = {
  0,
  BZ2_bzCompress,
  BZ2_bzCompressEnd,
  BZ2_bzCompressInit,
  BZ2_bzDecompress,
  BZ2_bzDecompressEnd,
  BZ2_bzDecompressInit,
};
#else
bzFunctions bz = {0}; /* THREADING: serialize initialization */
#endif


int
TrfLoadBZ2lib (interp)
    Tcl_Interp* interp;
{
#ifndef BZLIB_SHARED_BUILD
  int res;

  TrfLock; /* THREADING: serialize initialization */

  res = Trf_LoadLibrary (interp, BZ2_LIB_NAME, (VOID**) &bz, symbols, 6);
  TrfUnlock;

  return res;
#else
  return TCL_OK;
#endif
}
